## qmmp-2.0.0-1.src.tar.gz

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18.0 FATAL_ERROR)
project(qmmp)

#freebsd support
include_directories(SYSTEM /usr/local/include)
SET(CMAKE_REQUIRED_INCLUDES ${CMAKE_REQUIRED_INCLUDES} /usr/local/include)

#macports support
IF(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
  SET(CMAKE_REQUIRED_INCLUDES ${CMAKE_REQUIRED_INCLUDES} /opt/local/include)
ENDIF()

IF(POLICY CMP0071)
  cmake_policy(SET CMP0071 NEW)
ENDIF()

IF(POLICY CMP0063)
cmake_policy(SET CMP0063 NEW)
ENDIF()

#Qt6 modules
SET(CMAKE_PREFIX_PATH ${CMAKE_PREFIX_PATH} /home/user/qt6)

#installation paths
INCLUDE(GNUInstallDirs)
INCLUDE(FindPkgConfig)

#extract version from qmmp.h
FILE(STRINGS "${CMAKE_CURRENT_SOURCE_DIR}/src/qmmp/qmmp.h"
     QMMP_VERSION_DATA REGEX "^#define[ \t]+QMMP_VERSION_[A-Z]+[ \t]+[0-9]+.*$")

IF(QMMP_VERSION_DATA)
   FOREACH(item IN ITEMS MAJOR MINOR PATCH STABLE)
      STRING(REGEX REPLACE ".*#define[ \t]+QMMP_VERSION_${item}[ \t]+([0-9]+).*"
       "\\1" QMMP_VERSION_${item} ${QMMP_VERSION_DATA})
   ENDFOREACH(item IN ITEMS MAJOR MINOR PATCH)
   SET(QMMP_VERSION "${QMMP_VERSION_MAJOR}.${QMMP_VERSION_MINOR}.${QMMP_VERSION_PATCH}")
   SET(QMMP_SOVERSION "${QMMP_VERSION_MAJOR}")
   IF(QMMP_VERSION_STABLE)
      MESSAGE(STATUS "Qmmp API version: ${QMMP_VERSION} (stable)")
   ELSE(QMMP_VERSION_STABLE)
      MESSAGE(STATUS "Qmmp API version: ${QMMP_VERSION} (development)")
   ENDIF(QMMP_VERSION_STABLE)
ELSE(QMMP_VERSION_DATA)
   MESSAGE(FATAL_ERROR "invalid header")
ENDIF(QMMP_VERSION_DATA)

CONFIGURE_FILE(
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
  IMMEDIATE @ONLY)

ADD_CUSTOM_TARGET(uninstall
  "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_VISIBILITY_PRESET hidden)
set(CMAKE_VISIBILITY_INLINES_HIDDEN 1)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

ADD_DEFINITIONS(-DQMMP_WS_X11 -DQT_DISABLE_DEPRECATED_BEFORE=0x060100 -DQT_DEPRECATED_WARNINGS)

find_package(Qt6 6.1.0 CONFIG REQUIRED COMPONENTS Widgets LinguistTools Network)
find_package(Qt6 6.1.0 CONFIG OPTIONAL_COMPONENTS DBus OpenGLWidgets Sql BuildInternals)

get_target_property(QT_LRELEASE_EXECUTABLE Qt6::lrelease IMPORTED_LOCATION)

IF(QT_LRELEASE_EXECUTABLE)
MESSAGE(STATUS "Found lrelease executable: " ${QT_LRELEASE_EXECUTABLE})
ELSE(QT_LRELEASE_EXECUTABLE)
MESSAGE(FATAL_ERROR "Could NOT find lrelease executable")
ENDIF(QT_LRELEASE_EXECUTABLE)

MESSAGE(STATUS "Generating translations ...")
IF(SVN_VERSION)
execute_process(COMMAND find ${CMAKE_CURRENT_SOURCE_DIR} -name *.ts COMMAND xargs ${QT_LRELEASE_EXECUTABLE} -silent -nounfinished)
ELSE(SVN_VERSION)
execute_process(COMMAND find ${CMAKE_CURRENT_SOURCE_DIR} -name *.ts COMMAND xargs ${QT_LRELEASE_EXECUTABLE} -silent)
ENDIF(SVN_VERSION)

SET(PLUGIN_DIR "${CMAKE_INSTALL_LIBDIR}/qmmp-${QMMP_VERSION_MAJOR}.${QMMP_VERSION_MINOR}" CACHE STRING "plugin path")
SET(USE_SKINNED TRUE CACHE BOOL "enable/disable standard skinned user interface")
SET(USE_DIR_ASSOC TRUE CACHE BOOL "enable/disable inode/directory mime type association")
#SET(APP_NAME_SUFFIX "-1")

pkg_search_module(X11 x11)

add_subdirectory(src/qmmp)
add_subdirectory(src/qmmpui)
add_subdirectory(src/plugins)
add_subdirectory(src/app)
add_subdirectory(doc)

IF(MAD_FOUND)
  SET(MPEG_DECODERS "MAD")
ENDIF(MAD_FOUND)

IF(MPG123_FOUND)
  SET(MPEG_DECODERS ${MPEG_DECODERS} "mpg123")
ENDIF(MPG123_FOUND)

MACRO(PRINT_SUMMARY str USE FOUND)
IF(${USE} AND ${FOUND})
MESSAGE("${str}enabled")
ELSE(${USE} AND ${FOUND})
MESSAGE("${str}disabled")
ENDIF(${USE} AND ${FOUND})
ENDMACRO(PRINT_SUMMARY)

IF (UNIX)
ADD_CUSTOM_TARGET (distclean @echo cleaning for source distribution)

ADD_CUSTOM_COMMAND(
    COMMENT "distribution clean"
    COMMAND make
    ARGS -C ${CMAKE_CURRENT_BINARY_DIR} clean
    COMMAND find
    ARGS ${CMAKE_CURRENT_BINARY_DIR} -name "CMakeCache.txt" | xargs rm -rf
    COMMAND find
    ARGS ${CMAKE_CURRENT_BINARY_DIR} -name "CMakeFiles" | xargs rm -rf
    COMMAND find
    ARGS ${CMAKE_CURRENT_BINARY_DIR} -name "Makefile" | xargs rm -rf
    COMMAND find
    ARGS ${CMAKE_CURRENT_BINARY_DIR} -name \"*.cmake\" | xargs rm -rf
    COMMAND find
    ARGS ${CMAKE_CURRENT_SOURCE_DIR} -name "*.qm" | xargs rm -rf
    COMMAND find
    ARGS ${CMAKE_CURRENT_BINARY_DIR} -name "*.pc" | xargs rm -rf
    COMMAND find
    ARGS ${CMAKE_CURRENT_BINARY_DIR} -name "*.depends" | xargs rm -rf
    COMMAND find
    ARGS ${CMAKE_CURRENT_BINARY_DIR} -name "*.cxx_parameters" | xargs rm -rf
    COMMAND find
    ARGS ${CMAKE_CURRENT_BINARY_DIR} -name "moc_*.cpp" | xargs rm -rf
    COMMAND find
    ARGS ${CMAKE_CURRENT_BINARY_DIR} -name "qrc_*.cxx" | xargs rm -rf
    COMMAND find
    ARGS ${CMAKE_CURRENT_BINARY_DIR} -name "*_automoc.cpp" | xargs rm -rf
    COMMAND rm
    ARGS -rf ${CMAKE_CURRENT_BINARY_DIR}/install_manifest.txt
    COMMAND find
    ARGS ${CMAKE_CURRENT_BINARY_DIR} -name *_automoc.dir | xargs rm -rf
    COMMAND rm
    ARGS -rf ${CMAKE_CURRENT_BINARY_DIR}/doc/html
    TARGET  distclean
)
ENDIF(UNIX)


MESSAGE("")
MESSAGE("Transports:")
PRINT_SUMMARY ("HTTP support .........................." USE_CURL CURL_FOUND)
PRINT_SUMMARY ("MMS support ..........................." USE_MMS MMS_FOUND)

MESSAGE("")
MESSAGE("Input Plugins:")
PRINT_SUMMARY ("MPEG support .........................." 1 MAD_FOUND OR MPG123_FOUND)
PRINT_SUMMARY ("FLAC support .........................." USE_FLAC FLAC_FOUND)
PRINT_SUMMARY ("Ogg Vorbis support ...................." USE_VORBIS VORBIS_FOUND)
PRINT_SUMMARY ("Musepack support ......................" USE_MPC MPC_FOUND)
PRINT_SUMMARY ("MOD support ..........................." USE_MODPLUG MODPLUG_FOUND)
PRINT_SUMMARY ("Wave support .........................." USE_SNDFILE SNDFILE_FOUND)
PRINT_SUMMARY ("WavPack support ......................." USE_WAVPACK WAVPACK_FOUND)
PRINT_SUMMARY ("FFmpeg support ........................" USE_FFMPEG FFMPEG_FOUND)
PRINT_SUMMARY ("AAC support ..........................." USE_AAC FAAD_FOUND)
PRINT_SUMMARY ("CUE sheet support ....................." USE_CUE 1)
PRINT_SUMMARY ("Mplayer support ......................." USE_MPLAYER 1)
PRINT_SUMMARY ("CD Audio support ......................" USE_CDA CDIO_FOUND)
PRINT_SUMMARY ("Midi support .........................." USE_MIDI WILDMIDI_FOUND)
PRINT_SUMMARY ("Game music support ...................." USE_GME GME_FOUND)
PRINT_SUMMARY ("Ogg Opus support ......................" USE_OPUS OPUS_FOUND)
PRINT_SUMMARY ("SID support ..........................." USE_SID SIDPLAYFP_FOUND)
PRINT_SUMMARY ("Archive support ......................." USE_ARCHIVE LIBARCHIVE_FOUND)

MESSAGE("")
MESSAGE("Output Plugins:")
PRINT_SUMMARY ("ALSA support .........................." USE_ALSA ALSA_FOUND)
PRINT_SUMMARY ("OSS support ..........................." USE_OSS 1)
PRINT_SUMMARY ("OSS4 support .........................." USE_OSS4 OSS4_FOUND)
PRINT_SUMMARY ("JACK support .........................." USE_JACK JACK_FOUND)
PRINT_SUMMARY ("PulseAudio support ...................." USE_PULSE PULSE_FOUND)
PRINT_SUMMARY ("PipeWire support ......................" USE_PIPEWIRE PIPEWIRE_FOUND)
PRINT_SUMMARY ("Null output support ..................." USE_NULL 1)
PRINT_SUMMARY ("Waveout support (Windows) ............." USE_WAVEOUT WINDOWS_H_FOUND)
PRINT_SUMMARY ("DirectSound support (Windows) ........." USE_DSOUND DSOUND_H_FOUND)
PRINT_SUMMARY ("WASAPI support (Windows) .............." USE_WASAPI WASAPI_FOUND)
#PRINT_SUMMARY ("Qt Multimedia support ................." USE_QTMULTIMEDIA Qt6Multimedia_FOUND)
PRINT_SUMMARY ("Icecast support ......................." USE_SHOUT SHOUT_FOUND)

MESSAGE("")
MESSAGE("Effect Plugins:")
PRINT_SUMMARY ("SoX Resampler ........................." USE_SOXR SOXR_FOUND)
PRINT_SUMMARY ("BS2B Plugin ..........................." USE_BS2B BS2B_FOUND)
PRINT_SUMMARY ("LADSPA Host ..........................." USE_LADSPA 1)
PRINT_SUMMARY ("Crossfade ............................." USE_CROSSFADE 1)
PRINT_SUMMARY ("Extra Stereo .........................." USE_STEREO 1)
PRINT_SUMMARY ("File Writer ..........................." USE_FILEWRITER VORBISENC_FOUND)
PRINT_SUMMARY ("Mono to Stereo Converter .............." USE_MONOTOSTEREO 1)

MESSAGE("")
MESSAGE("Visual Plugins:")
PRINT_SUMMARY ("Analyzer .............................." USE_ANALYZER 1)
PRINT_SUMMARY ("ProjectM .............................." USE_PROJECTM PROJECTM_FOUND)

MESSAGE("")
MESSAGE("General Plugins:")
PRINT_SUMMARY ("MPRIS support ........................." USE_MPRIS Qt6DBus_FOUND)
PRINT_SUMMARY ("Scrobbler ............................." USE_SCROBBLER 1)
PRINT_SUMMARY ("ListenBrainz .........................." USE_LISTENBRAINZ 1)
PRINT_SUMMARY ("Tray support .........................." USE_STATICON 1)
PRINT_SUMMARY ("Notifier support ......................" USE_NOTIFIER 1)
PRINT_SUMMARY ("Lyrics support ........................" USE_LYRICS 1)
PRINT_SUMMARY ("HAL support ..........................." USE_HAL Qt6DBus_FOUND)
PRINT_SUMMARY ("UDisks2 support ......................." USE_UDISKS2 Qt6DBus_FOUND)
PRINT_SUMMARY ("Global hotkey support ................." USE_HOTKEY X11_FOUND AND XCB_H_FOUND AND Qt6BuildInternals_FOUND)
PRINT_SUMMARY ("GNOME/Cinnamon hotkey support ........." USE_GNOMEHOTKEY Qt6DBus_FOUND)
PRINT_SUMMARY ("File operations ......................." USE_FILEOPS 1)
PRINT_SUMMARY ("Cover manager ........................." USE_COVER 1)
PRINT_SUMMARY ("KDE notifications support ............." USE_KDENOTIFY Qt6DBus_FOUND)
PRINT_SUMMARY ("Audio converter ......................." USE_CONVERTER TAGLIB_FOUND)
PRINT_SUMMARY ("ReplayGain Scanner ...................." USE_RGSCAN TAGLIB_FOUND)
PRINT_SUMMARY ("Stream browser ........................" USE_SB 1)
PRINT_SUMMARY ("Track change .........................." USE_TRACKCHANGE 1)
PRINT_SUMMARY ("Copy/Paste ............................" USE_COPYPASTE 1)
PRINT_SUMMARY ("History plugin ........................" USE_HISTORY Qt6Sql_FOUND)
PRINT_SUMMARY ("Sleep mode inhibition plugin .........." USE_SLEEPINHIBITOR Qt6DBus_FOUND)
PRINT_SUMMARY ("Media library plugin .................." USE_LIBRARY Qt6Sql_FOUND)
#PRINT_SUMMARY ("Taskbar plugin (Windows) .............." USE_TASKBAR Qt6WinExtras_FOUND)
PRINT_SUMMARY ("Removable device detection (Windows) .." USE_RDETECT Qt6WinExtras_FOUND)

MESSAGE("")
MESSAGE("File Dialogs:")
PRINT_SUMMARY ("QMMP File Dialog ......................" USE_QMMP_DIALOG 1)
PRINT_SUMMARY ("Two-panel File File Dialog ............" USE_TWO_PANEL_DIALOG 1)

MESSAGE("")
MESSAGE("Advanced:")
PRINT_SUMMARY ("Skinned user interface ................" USE_SKINNED X11_FOUND AND Qt6BuildInternals_FOUND)
PRINT_SUMMARY ("Simple user interface (QSUI) .........." USE_QSUI 1)
PRINT_SUMMARY ("Automatic charset detection ..........." USE_ENCA ENCA_FOUND)
PRINT_SUMMARY ("MPEG plugin with LibRCD support ......." USE_LIBRCD LIBRCD_FOUND)
PRINT_SUMMARY ("Directory association ................." USE_DIR_ASSOC 1)
PRINT_SUMMARY ("Set RPATH in installed binaries ......." CMAKE_INSTALL_RPATH_USE_LINK_PATH 1)
IF(MPEG_DECODERS)
MESSAGE       ("MPEG decoders ........................." "${MPEG_DECODERS}")
ENDIF(MPEG_DECODERS)

MESSAGE("")

=== src/app/CMakeLists.txt ===
project(app)

INCLUDE(UsePkgConfig)

include_directories(${CMAKE_CURRENT_SOURCE_DIR})

# libqmmp & libqmmpui
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../)

link_directories(${CMAKE_INSTALL_PREFIX}/${LIB_DIR})
link_directories(${CMAKE_CURRENT_BINARY_DIR}/../qmmpui)
link_directories(${CMAKE_CURRENT_BINARY_DIR}/../qmmp)

SET(app_SRCS
    builtincommandlineoption.cpp
    main.cpp
    qmmpstarter.cpp
    images/images.qrc
    translations/qmmp_locales.qrc
)

# Don't forget to include output directory, otherwise
# the UI file won't be wrapped!
include_directories(${CMAKE_CURRENT_BINARY_DIR})

ADD_EXECUTABLE(qmmp ${app_SRCS})
target_link_libraries(qmmp PRIVATE Qt6::Widgets Qt6::Network libqmmp libqmmpui)
SET_TARGET_PROPERTIES(qmmp PROPERTIES OUTPUT_NAME qmmp${APP_NAME_SUFFIX})
add_dependencies(qmmp libqmmpui libqmmp)

install(TARGETS qmmp DESTINATION ${CMAKE_INSTALL_BINDIR})
install(FILES qmmp-opencda${APP_NAME_SUFFIX}.desktop DESTINATION ${CMAKE_INSTALL_DATADIR}/solid/actions)
install(FILES qmmp${APP_NAME_SUFFIX}.desktop DESTINATION ${CMAKE_INSTALL_DATADIR}/applications)
install(FILES images/16x16/qmmp${APP_NAME_SUFFIX}.png DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/16x16/apps)
install(FILES images/32x32/qmmp${APP_NAME_SUFFIX}.png DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/32x32/apps)
install(FILES images/48x48/qmmp${APP_NAME_SUFFIX}.png DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/48x48/apps)
install(FILES images/56x56/qmmp${APP_NAME_SUFFIX}.png DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/56x56/apps)
install(FILES images/64x64/qmmp${APP_NAME_SUFFIX}.png DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/64x64/apps)
install(FILES images/128x128/qmmp${APP_NAME_SUFFIX}.png DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/128x128/apps)
install(FILES images/256x256/qmmp${APP_NAME_SUFFIX}.png DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/256x256/apps)
install(FILES images/scalable/qmmp${APP_NAME_SUFFIX}.svgz images/scalable/qmmp-simple${APP_NAME_SUFFIX}.svgz DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/scalable/apps)
install(FILES appdata/qmmp${APP_NAME_SUFFIX}.appdata.xml DESTINATION ${CMAKE_INSTALL_DATADIR}/metainfo)

IF(USE_DIR_ASSOC)
    install(FILES qmmp-enqueue${APP_NAME_SUFFIX}.desktop DESTINATION ${CMAKE_INSTALL_DATADIR}/applications)
    install(FILES qmmp-dir${APP_NAME_SUFFIX}.desktop DESTINATION ${CMAKE_INSTALL_DATADIR}/applications)
ENDIF(USE_DIR_ASSOC)

=== src/plugins/CMakeLists.txt ===
SET(USE_ENCA TRUE CACHE BOOL "enable/disable libenca support")
include(FindPkgConfig)
pkg_search_module(ENCA enca>=1.9)
pkg_search_module(TAGLIB taglib>=1.12)
add_subdirectory(Input)
add_subdirectory(Output)
add_subdirectory(Visual)
add_subdirectory(Effect)
add_subdirectory(General)
add_subdirectory(PlayListFormats)
add_subdirectory(CommandLineOptions)
add_subdirectory(FileDialogs)
add_subdirectory(Transports)
add_subdirectory(Engines)
add_subdirectory(Ui)

=== src/qmmp/CMakeLists.txt ===
project(libqmmp)

ADD_DEFINITIONS(-DQMMP_LIBRARY)
SET(libqmmp_DEFINES
    LIB_DIR="/${LIB_DIR}"
    QMMP_INSTALL_PREFIX="${CMAKE_INSTALL_PREFIX}"
    APP_NAME_SUFFIX="${APP_NAME_SUFFIX}"
)

IF(NOT QMMP_VERSION_STABLE) #add svn revision
execute_process(COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/svn_revision.sh
                WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
                OUTPUT_VARIABLE SVN_REVISION
                OUTPUT_STRIP_TRAILING_WHITESPACE)
IF(SVN_REVISION)
SET(libqmmp_DEFINES ${libqmmp_DEFINES} SVN_REVISION="${SVN_REVISION}")
ENDIF(SVN_REVISION)
ENDIF(NOT QMMP_VERSION_STABLE)

SET(libqmmp_DEFINES ${libqmmp_DEFINES} QMMP_PLUGIN_DIR="${CMAKE_INSTALL_PREFIX}/${PLUGIN_DIR}")

include_directories(${CMAKE_CURRENT_BINARY_DIR})

SET(QMMP_DEFAULT_OUTPUT "" CACHE STRING "default output plugin")
IF(QMMP_DEFAULT_OUTPUT)
    SET(libqmmp_DEFINES ${libqmmp_DEFINES} QMMP_DEFAULT_OUTPUT="${QMMP_DEFAULT_OUTPUT}")
    MESSAGE(STATUS "Default output: ${QMMP_DEFAULT_OUTPUT}")
ENDIF(QMMP_DEFAULT_OUTPUT)


SET(libqmmp_SRCS
    visual.cpp
    recycler.cpp
    decoder.cpp
    output.cpp
    outputwriter.cpp
    trackinfo.cpp
    equ/iir.c
    equ/iir_cfs.c
    equ/iir_fpu.c
    soundcore.cpp
    effect.cpp
    qmmp.cpp
    statehandler.cpp
    volumehandler.cpp
    metadatamodel.cpp
    tagmodel.cpp
    qmmpaudioengine.cpp
    abstractengine.cpp
    audioparameters.cpp
    inputsource.cpp
    fileinputsource.cpp
    emptyinputsource.cpp
    metadatamanager.cpp
    replaygain.cpp
    qmmpsettings.cpp
    audioconverter.cpp
    eqsettings.cpp
    qmmpevents.cpp
    qmmpplugincache.cpp
    channelmap.cpp
    channelconverter.cpp
    volume.cpp
    dithering.cpp
    visualbuffer.cpp
    cueparser.cpp
    qmmptextcodec.cpp
)

SET(libqmmp_DEVEL_HDRS
    abstractengine.h
    audioconverter.h
    audioparameters.h
    buffer.h
    channelmap.h
    decoderfactory.h
    decoder.h
    effectfactory.h
    effect.h
    enginefactory.h
    eqsettings.h
    trackinfo.h
    inputsourcefactory.h
    inputsource.h
    metadatamanager.h
    metadatamodel.h
    outputfactory.h
    output.h
    qmmp.h
    qmmpsettings.h
    soundcore.h
    statehandler.h
    tagmodel.h
    trackinfo.h
    visualfactory.h
    visual.h
    volume.h
    volumehandler.h
    cueparser.h
    qmmptextcodec.h
    qmmp_export.h
)

# Don't forget to include output directory, otherwise
# the UI file won't be wrapped!
include_directories(${CMAKE_CURRENT_BINARY_DIR})

ADD_LIBRARY(libqmmp SHARED ${libqmmp_SRCS})
target_link_libraries(libqmmp PRIVATE Qt6::Widgets)
SET_TARGET_PROPERTIES(libqmmp PROPERTIES VERSION ${QMMP_VERSION} SOVERSION ${QMMP_SOVERSION} OUTPUT_NAME qmmp${APP_NAME_SUFFIX})
target_compile_definitions(libqmmp PRIVATE ${libqmmp_DEFINES})
install(TARGETS libqmmp LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
                        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
                        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})

IF(APP_NAME_SUFFIX)
    install(FILES ${libqmmp_DEVEL_HDRS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/qmmp${APP_NAME_SUFFIX}/qmmp)
    SET(QMMP_INCLUDE_DIR ${CMAKE_INSTALL_FULL_INCLUDEDIR}/qmmp${APP_NAME_SUFFIX})
ELSE()
    install(FILES ${libqmmp_DEVEL_HDRS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/qmmp)
    SET(QMMP_INCLUDE_DIR ${CMAKE_INSTALL_FULL_INCLUDEDIR})
ENDIF()

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/qmmp.pc.in ${CMAKE_CURRENT_BINARY_DIR}/qmmp${APP_NAME_SUFFIX}.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/qmmp${APP_NAME_SUFFIX}.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

=== src/qmmpui/CMakeLists.txt ===
project(libqmmpui)

ADD_DEFINITIONS(-DQMMPUI_LIBRARY)

include_directories(${CMAKE_CURRENT_SOURCE_DIR})

# libqmmp
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../)

link_directories(${CMAKE_INSTALL_PREFIX}/${LIB_DIR})
link_directories(${CMAKE_CURRENT_BINARY_DIR}/../qmmp)

SET(QMMP_DEFAULT_UI "" CACHE STRING "default user interface")
IF(QMMP_DEFAULT_UI)
    SET(libqmmpui_DEFINES ${libqmmpui_DEFINES} QMMP_DEFAULT_UI="${QMMP_DEFAULT_OUTPUT}")
    MESSAGE(STATUS "Default user interface: ${QMMP_DEFAULT_UI}")
ENDIF(QMMP_DEFAULT_UI)


SET(libqmmpui_SRCS
    general.cpp
    uihelper.cpp
    playlistparser.cpp
    commandlinemanager.cpp
    commandlinehandler.cpp
    filedialog.cpp
    qtfiledialog.cpp
    fileloader.cpp
    playstate.cpp
    playlistmodel.cpp
    playlistitem.cpp
    playlistgroup.cpp
    playlisttrack.cpp
    playlistcontainer.cpp
    normalcontainer.cpp
    groupedcontainer.cpp
    mediaplayer.cpp
    detailsdialog.cpp
    tageditor.cpp
    playlistmanager.cpp
    metadataformatter.cpp
    metadataformattermenu.cpp
    templateeditor.cpp
    uiloader.cpp
    jumptotrackdialog.cpp
    configdialog.cpp
    pluginitem.cpp
    aboutdialog.cpp
    qmmpuisettings.cpp
    radioitemdelegate.cpp
    playlistdownloader.cpp
    addurldialog.cpp
    qmmpuiplugincache.cpp
    playlisttask.cpp
    playlistheadermodel.cpp
    columneditor.cpp
    metadatahelper.cpp
    coverviewer.cpp
    covereditor.cpp
    generalfactory.cpp
    cueeditor.cpp
    forms/detailsdialog.ui
    forms/tageditor.ui
    forms/templateeditor.ui
    forms/jumptotrackdialog.ui
    forms/configdialog.ui
    forms/aboutdialog.ui
    forms/addurldialog.ui
    forms/columneditor.ui
    forms/covereditor.ui
    forms/cueeditor.ui
    translations/libqmmpui_locales.qrc
    txt/txt.qrc
    images/qmmpui_images.qrc
)

SET(libqmmpui_DEVEL_HDRS
    commandlinemanager.h
    commandlinehandler.h
    configdialog.h
    detailsdialog.h
    filedialogfactory.h
    filedialog.h
    generalfactory.h
    general.h
    mediaplayer.h
    metadataformatter.h
    metadataformattermenu.h
    playlistdownloader.h
    playlistformat.h
    playlistitem.h
    playlistgroup.h
    playlisttrack.h
    playlistmanager.h
    playlistmodel.h
    playlistparser.h
    qmmpuisettings.h
    templateeditor.h
    uifactory.h
    uihelper.h
    uiloader.h
    playlistheadermodel.h
    qmmpui_export.h
)

include_directories(${CMAKE_CURRENT_BINARY_DIR})
SET(CMAKE_AUTOUIC_SEARCH_PATHS ${CMAKE_AUTOUIC_SEARCH_PATHS} ${CMAKE_CURRENT_SOURCE_DIR}/forms)

ADD_LIBRARY(libqmmpui SHARED ${libqmmpui_SRCS})
target_link_libraries(libqmmpui PRIVATE Qt6::Widgets Qt6::Network libqmmp)
add_dependencies(libqmmpui libqmmp)
SET_TARGET_PROPERTIES(libqmmpui PROPERTIES VERSION ${QMMP_VERSION} SOVERSION ${QMMP_SOVERSION} OUTPUT_NAME qmmpui${APP_NAME_SUFFIX})
target_compile_definitions(libqmmpui PRIVATE ${libqmmpui_DEFINES})
install(TARGETS libqmmpui LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
                          RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
                          ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})


IF(APP_NAME_SUFFIX)
    install(FILES ${libqmmpui_DEVEL_HDRS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/qmmp${APP_NAME_SUFFIX}/qmmpui)
    SET(QMMP_INCLUDE_DIR ${CMAKE_INSTALL_FULL_INCLUDEDIR}/qmmp${APP_NAME_SUFFIX})
ELSE()
    install(FILES ${libqmmpui_DEVEL_HDRS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/qmmpui)
    SET(QMMP_INCLUDE_DIR ${CMAKE_INSTALL_FULL_INCLUDEDIR})
ENDIF()

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/qmmpui.pc.in ${CMAKE_CURRENT_BINARY_DIR}/qmmpui${APP_NAME_SUFFIX}.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/qmmpui${APP_NAME_SUFFIX}.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

=== src/plugins/General/CMakeLists.txt ===
SET(USE_MPRIS TRUE CACHE BOOL "enable/disable mpris plugin")
SET(USE_SCROBBLER TRUE CACHE BOOL "enable/disable scrobbler plugin")
SET(USE_LISTENBRAINZ TRUE CACHE BOOL "enable/disable listenbrainz plugin")
SET(USE_STATICON TRUE CACHE BOOL "enable/disable status icon plugin")
SET(USE_NOTIFIER TRUE CACHE BOOL "enable/disable notifier plugin")
SET(USE_LYRICS TRUE CACHE BOOL "enable/disable lyrics version")
SET(USE_HAL (${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD") CACHE BOOL "enable/disable hal plugin")
SET(USE_UDISKS2 TRUE CACHE BOOL "enable/disable udisks2 plugin")
SET(USE_HOTKEY TRUE CACHE BOOL "enable/disable global hotkey plugin")
SET(USE_GNOMEHOTKEY TRUE CACHE BOOL "enable/disable gnome hotkey plugin")
SET(USE_FILEOPS TRUE CACHE BOOL "enable/disable fileops plugin")
SET(USE_COVER TRUE CACHE BOOL "enable/disable cover manager plugin")
SET(USE_KDENOTIFY TRUE CACHE BOOL "enable/disable kde notification plugin")
SET(USE_CONVERTER TRUE CACHE BOOL "enable/disable audio converter plugin")
SET(USE_RGSCAN TRUE CACHE BOOL "enable/disable replaygain scanner plugin")
SET(USE_SB TRUE CACHE BOOL "enable/disable stream browser plugin")
SET(USE_TRACKCHANGE TRUE CACHE BOOL "enable/disable track change plugin")
SET(USE_COPYPASTE TRUE CACHE BOOL "enable/disable copy/paste change plugin")
SET(USE_HISTORY TRUE CACHE BOOL "enable/disable history plugin")
SET(USE_SLEEPINHIBITOR TRUE CACHE BOOL "enable/disable sleep mode inhibition plugin")
SET(USE_LIBRARY TRUE CACHE BOOL "enable/disable media library plugin")
#SET(USE_TASKBAR TRUE CACHE BOOL "enable/disable taskbar plugin (Windows)")
SET(USE_RDETECT TRUE CACHE BOOL "enable/disable rdetect plugin (Windows)")

IF(USE_MPRIS AND Qt6DBus_FOUND)
add_subdirectory(mpris)
ENDIF(USE_MPRIS AND Qt6DBus_FOUND)

IF(USE_SCROBBLER)
add_subdirectory(scrobbler)
ENDIF(USE_SCROBBLER)

IF(USE_LISTENBRAINZ)
add_subdirectory(listenbrainz)
ENDIF(USE_LISTENBRAINZ)

IF(USE_STATICON)
add_subdirectory(statusicon)
ENDIF(USE_STATICON)

IF(USE_NOTIFIER)
add_subdirectory(notifier)
ENDIF(USE_NOTIFIER)

IF(USE_LYRICS)
add_subdirectory(lyrics)
ENDIF(USE_LYRICS)

IF(USE_HAL AND Qt6DBus_FOUND)
add_subdirectory(hal)
ENDIF(USE_HAL AND Qt6DBus_FOUND)

IF(USE_UDISKS2 AND Qt6DBus_FOUND)
add_subdirectory(udisks2)
ENDIF(USE_UDISKS2 AND Qt6DBus_FOUND)

IF(USE_HOTKEY AND Qt6BuildInternals_FOUND)
add_subdirectory(hotkey)
ENDIF(USE_HOTKEY AND Qt6BuildInternals_FOUND)

IF(USE_FILEOPS)
add_subdirectory(fileops)
ENDIF(USE_FILEOPS)

IF(USE_COVER)
add_subdirectory(covermanager)
ENDIF(USE_COVER)

IF(USE_KDENOTIFY AND Qt6DBus_FOUND)
add_subdirectory(kdenotify)
ENDIF(USE_KDENOTIFY AND Qt6DBus_FOUND)

IF(USE_CONVERTER AND TAGLIB_FOUND)
add_subdirectory(converter)
ENDIF(USE_CONVERTER AND TAGLIB_FOUND)

IF(USE_RGSCAN AND TAGLIB_FOUND)
add_subdirectory(rgscan)
ENDIF(USE_RGSCAN AND TAGLIB_FOUND)

IF(USE_SB)
add_subdirectory(streambrowser)
ENDIF(USE_SB)

IF(USE_TRACKCHANGE)
add_subdirectory(trackchange)
ENDIF(USE_TRACKCHANGE)

IF(USE_COPYPASTE)
add_subdirectory(copypaste)
ENDIF(USE_COPYPASTE)

IF(USE_GNOMEHOTKEY AND Qt6DBus_FOUND)
add_subdirectory(gnomehotkey)
ENDIF(USE_GNOMEHOTKEY AND Qt6DBus_FOUND)

IF(USE_HISTORY AND Qt6Sql_FOUND)
add_subdirectory(history)
ENDIF(USE_HISTORY AND Qt6Sql_FOUND)

IF(USE_SLEEPINHIBITOR AND Qt6DBus_FOUND)
add_subdirectory(sleepinhibitor)
ENDIF(USE_SLEEPINHIBITOR AND Qt6DBus_FOUND)

#IF(USE_TASKBAR AND Qt6WinExtras_FOUND)
#add_subdirectory(taskbar)
#ENDIF(USE_TASKBAR AND Qt6WinExtras_FOUND)

IF(USE_RDETECT AND MINGW)
add_subdirectory(rdetect)
ENDIF(USE_RDETECT AND MINGW)

IF(USE_LIBRARY AND Qt6Sql_FOUND)
add_subdirectory(library)
ENDIF(USE_LIBRARY AND Qt6Sql_FOUND)

=== src/plugins/Input/CMakeLists.txt ===
SET(USE_MAD            TRUE CACHE BOOL "enable/disable mad decoder (mpeg plugin)")
SET(USE_MPG123         TRUE CACHE BOOL "enable/disable mpg123 decoder (mpeg plugin)")
SET(USE_FLAC           TRUE CACHE BOOL "enable/disable flac plugin")
SET(USE_VORBIS         TRUE CACHE BOOL "enable/disable ogg vorbis plugin")
SET(USE_FFMPEG         TRUE CACHE BOOL "enable/disable ffmpeg plugin")
SET(USE_MPC            TRUE CACHE BOOL "enable/disable mpc plugin")
SET(USE_SNDFILE        TRUE CACHE BOOL "enable/disable sndfile plugin")
SET(USE_WAVPACK        TRUE CACHE BOOL "enable/disable wavpack plugin")
SET(USE_MODPLUG        TRUE CACHE BOOL "enable/disable modplug plugin")
SET(USE_AAC            TRUE CACHE BOOL "enable/disable aac plugin")
SET(USE_CUE            TRUE CACHE BOOL "enable/disable cue plugin")
SET(USE_CDA            TRUE CACHE BOOL "enable/disable cd audio support")
SET(USE_MIDI           TRUE CACHE BOOL "enable/disable midi support")
SET(USE_GME            TRUE CACHE BOOL "enable/disable game music plugin")
SET(USE_OPUS           TRUE CACHE BOOL "enable/disable opus plugin")
SET(USE_SID            TRUE CACHE BOOL "enable/disable sid plugin")
SET(USE_ARCHIVE        TRUE CACHE BOOL "enable/disable archive plugin")


IF((USE_MAD OR USE_MPG123) AND TAGLIB_FOUND)
add_subdirectory(mpeg)
ENDIF((USE_MAD OR USE_MPG123) AND TAGLIB_FOUND)

IF(USE_FLAC AND TAGLIB_FOUND)
add_subdirectory(flac)
ENDIF(USE_FLAC AND TAGLIB_FOUND)

IF(USE_VORBIS AND TAGLIB_FOUND)
add_subdirectory(vorbis)
ENDIF(USE_VORBIS AND TAGLIB_FOUND)

IF(USE_FFMPEG AND TAGLIB_FOUND)
add_subdirectory(ffmpeg)
ENDIF(USE_FFMPEG AND TAGLIB_FOUND)

IF(USE_MPC AND TAGLIB_FOUND)
add_subdirectory(mpc)
ENDIF(USE_MPC AND TAGLIB_FOUND)

IF(USE_SNDFILE)
add_subdirectory(sndfile)
ENDIF(USE_SNDFILE)

IF(USE_WAVPACK)
add_subdirectory(wavpack)
ENDIF(USE_WAVPACK)

IF(USE_MODPLUG)
add_subdirectory(modplug)
ENDIF(USE_MODPLUG)

IF(USE_AAC AND TAGLIB_FOUND)
add_subdirectory(aac)
ENDIF(USE_AAC AND TAGLIB_FOUND)

IF(USE_CUE)
add_subdirectory(cue)
ENDIF(USE_CUE)

IF(USE_CDA)
add_subdirectory(cdaudio)
ENDIF(USE_CDA)

IF(USE_MIDI)
add_subdirectory(wildmidi)
ENDIF(USE_MIDI)

IF(USE_GME)
add_subdirectory(gme)
ENDIF(USE_GME)

IF(USE_OPUS AND TAGLIB_FOUND)
add_subdirectory(opus)
ENDIF(USE_OPUS AND TAGLIB_FOUND)

IF(USE_SID)
add_subdirectory(sid)
ENDIF(USE_SID)

IF(USE_ARCHIVE AND TAGLIB_FOUND)
add_subdirectory(archive)
ENDIF(USE_ARCHIVE AND TAGLIB_FOUND)

=== src/plugins/Ui/CMakeLists.txt ===
SET(USE_SKINNED TRUE CACHE BOOL "enable/disable skinned user interface")
SET(USE_QSUI TRUE CACHE BOOL "enable/disable simple user interface (qsui)")

IF(USE_SKINNED AND Qt6BuildInternals_FOUND)
add_subdirectory(skinned)
ENDIF(USE_SKINNED AND Qt6BuildInternals_FOUND)

IF(USE_QSUI)
add_subdirectory(qsui)
ENDIF(USE_QSUI)

=== src/plugins/CommandLineOptions/IncDecVolumeOption/CMakeLists.txt ===
project(libincdecvolumeoption)

include_directories(${CMAKE_CURRENT_BINARY_DIR})

# libqmmpui
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../../../)
link_directories(${CMAKE_CURRENT_BINARY_DIR}/../../../qmmpui)
link_directories(${CMAKE_CURRENT_BINARY_DIR}/../../../qmmp)

SET(libincdecvolumeoption_SRCS
    incdecvolumeoption.cpp
    translations/translations.qrc
)

ADD_LIBRARY(incdecvolumeoption MODULE ${libincdecvolumeoption_SRCS})
add_dependencies(incdecvolumeoption libqmmpui)
target_link_libraries(incdecvolumeoption PRIVATE Qt6::Widgets libqmmpui libqmmp)
install(TARGETS incdecvolumeoption DESTINATION ${PLUGIN_DIR}/CommandLineOptions)

=== src/plugins/CommandLineOptions/PlayListOption/CMakeLists.txt ===
project(libplaylistoption)

include_directories(${CMAKE_CURRENT_BINARY_DIR})

# libqmmpui
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../../../)
link_directories(${CMAKE_CURRENT_BINARY_DIR}/../../../qmmpui)
link_directories(${CMAKE_CURRENT_BINARY_DIR}/../../../qmmp)

SET(libplaylistoption_SRCS
    playlistoption.cpp
    translations/translations.qrc
)

ADD_LIBRARY(playlistoption MODULE ${libplaylistoption_SRCS})
add_dependencies(playlistoption libqmmpui)
target_link_libraries(playlistoption PRIVATE Qt6::Widgets libqmmpui libqmmp)
install(TARGETS playlistoption DESTINATION ${PLUGIN_DIR}/CommandLineOptions)

=== src/plugins/CommandLineOptions/SeekOption/CMakeLists.txt ===
project(seekoption)

include_directories(${CMAKE_CURRENT_BINARY_DIR})

# libqmmpui
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../../../)
link_directories(${CMAKE_CURRENT_BINARY_DIR}/../../../qmmpui)
link_directories(${CMAKE_CURRENT_BINARY_DIR}/../../../qmmp)

SET(seekoption_SRCS
    seekoption.cpp
    translations/translations.qrc
)

ADD_LIBRARY(seekoption MODULE ${seekoption_SRCS})
add_dependencies(seekoption libqmmpui)
target_link_libraries(seekoption PRIVATE Qt6::Widgets libqmmpui libqmmp)
install(TARGETS seekoption DESTINATION ${PLUGIN_DIR}/CommandLineOptions)

=== src/plugins/CommandLineOptions/StatusOption/CMakeLists.txt ===
project(statusoption)

include_directories(${CMAKE_CURRENT_BINARY_DIR})

# libqmmpui
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../../../)
link_directories(${CMAKE_CURRENT_BINARY_DIR}/../../../qmmpui)
link_directories(${CMAKE_CURRENT_BINARY_DIR}/../../../qmmp)

SET(statusoption_SRCS
    statusoption.cpp
    translations/translations.qrc
)

ADD_LIBRARY(statusoption MODULE ${statusoption_SRCS})
add_dependencies(statusoption libqmmpui)
target_link_libraries(statusoption Qt6::Widgets libqmmpui libqmmp)
install(TARGETS statusoption DESTINATION ${PLUGIN_DIR}/CommandLineOptions)

=== PKGBUILD ===
# Maintainer: Jaroslav Lichtblau <svetlemodry@archlinux.org>

pkgname=qmmp
pkgver=2.0.0
pkgrel=1
pkgdesc="Qt5 based audio-player"
arch=('x86_64')
url="http://qmmp.ylsoftware.com/"
license=('GPL')
depends=('alsa-lib' 'curl' 'desktop-file-utils' 'hicolor-icon-theme' 'libmad' 'libvorbis'
         'libogg' 'libxkbcommon-x11' 'taglib' 'xdg-utils' 'qt6-base') #'qt6-multimedia'
makedepends=('cmake' 'flac' 'jack' 'libmpcdec' 'pipewire' 'pulseaudio' 'ffmpeg' 'libcdio-paranoia'
             'libcddb' 'libmms' 'libsamplerate' 'libmodplug' 'libsndfile' 'wavpack' 'mpg123' 'mesa'
             'projectm' 'faad2' 'libgme' 'libsidplayfp' 'opusfile>=0.12' 'wildmidi' 'qt6-tools')
optdepends=('flac: native FLAC support'
            'jack: JACK sound output'
            'libmpcdec: Musepack support'
            'pulseaudio: PulseAudio output'
            'pipewire: pipewire support'
            'libcdio-paranoia: Compact Disc input and control support'
            'libcddb: CDDB server support'
            'libmms: MMS stream protocol support'
            'libmodplug: MOD playing library'
            'libsndfile: sampled sound support'
            'projectm: visual efects'
            'faad2: ADTS AAC support'
            'libgme: support for chiptunes from various platforms'
            'libsidplayfp: C64 music support'
            'opusfile: Opus support'
            'wildmidi: MIDI support'
            'ffmpeg' 'libsamplerate' 'wavpack' 'mpg123')
changelog=$pkgname.changelog
source=(http://qmmp.ylsoftware.com/files/$pkgname/2.0/$pkgname-$pkgver.tar.bz2)
sha512sums=('65592540e35827eec26bccd50acdca1f97a6731e78e14021d36fff3c46e3dab02cf38968c35b8185ef56b1dbfcb01aaf6fdd58ae13e8e788f3cf9010d3162f15')

build() {
  cd "${srcdir}"/$pkgname-$pkgver

  cmake . -DCMAKE_INSTALL_PREFIX=/usr \
          -DCMAKE_INSTALL_LIBDIR=lib \
          -DUSE_HAL:BOOL=FALSE
  make
}

package() {
  cd "${srcdir}"/$pkgname-$pkgver

  make DESTDIR="${pkgdir}" install
}
